package com.sobot.utils;

import android.app.Activity;
import android.content.Context;

import java.util.LinkedList;
import java.util.List;

/**
 * @Description: 全局上下文
 * @Author: znw
 * @Date: 2021/7/19 下午2:17
 * @Version: 1.0
 */
public class SobotGlobalContext {
    private Context mApplicationContext;
    private List<Activity> activityList = new LinkedList<Activity>();

    private SobotGlobalContext() {
    }

    public static SobotGlobalContext getInstance(Context context) {
        if (SobotGlobalContext.GlobalContext.globalContext.mApplicationContext == null && context != null) {
            SobotGlobalContext.GlobalContext.globalContext.mApplicationContext = context;
        }
        return SobotGlobalContext.GlobalContext.globalContext;
    }

    public static Context getAppContext(Context context) {
        if (SobotGlobalContext.GlobalContext.globalContext.mApplicationContext == null && context != null) {
            SobotGlobalContext.GlobalContext.globalContext.mApplicationContext = context.getApplicationContext();
        }
        return SobotGlobalContext.GlobalContext.globalContext.mApplicationContext;
    }

    public static Context getAppContext() {
        return SobotGlobalContext.GlobalContext.globalContext.mApplicationContext;
    }

    private static class GlobalContext {
        private static final SobotGlobalContext globalContext = new SobotGlobalContext();

        private GlobalContext() {
        }
    }

    // 添加activity到容器中
    public void addActivity(Activity aty) {
        activityList.add(aty);
    }

    /*退出时关闭所有的activity*/
    public void exit() {
        for (Activity activity : activityList) {
            activity.finish();
        }
    }


    /*获取智齿最后一个activity*/
    public Activity getLastActivity() {
        if (activityList != null && activityList.size() > 0) {
            return activityList.get(activityList.size() - 1);
        }
        return null;
    }

    public void deleteActivity(Activity aty) {
        activityList.remove(aty);
    }
}